communication/urls.py
from django.urls import path
from .views import MessagesListView, MessagesDetailView, MessagesSendView
app_name = 'communication'

urlpatterns = [
    path('list/', MessagesListView.as_view(), name='messages_list'),
    path('detail/<int:user_id>/', MessagesDetailView.as_view(), name='messages_detail'),
    path('detail/<int:user_id>/send', MessagesSendView.as_view(), name='messages_send'),
]

main/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
urlpatterns = [
    path('admin/', admin.site.urls),
    path('user/', include('users.urls')),
    path('communication/', include('communication.urls')),
    path('', include('items.urls')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

users/urls.py
from django.urls import path, include
from .views import RegistrationView,Login,PasswordResetView,ProfileDetailView,ProfileUpdateView,PasswordChangeView
from django.urls import reverse_lazy
from django.contrib.auth.views import LogoutView
app_name = 'users'
urlpatterns = [
    path('register/', RegistrationView.as_view(), name='register' ),
    path('login/', Login.as_view(), name='login' ),
    path('logout/', LogoutView.as_view(next_page = "/user/logged_out/"), name='logout'),
    path('logged_out/', LogoutView.as_view(next_page=None,template_name="user/logged_out.html"), name='logged_out'),
    path('reset_password/', PasswordResetView.as_view(), name='reset_password' ),
    path('profile/<int:pk>/', ProfileDetailView.as_view(), name='user_profile' ),
    path('profile/me/', ProfileDetailView.as_view(is_me=True), name='me' ),
    path('profile/edit/', ProfileUpdateView.as_view(), name='profile_update' ),
    path('change_password/', PasswordChangeView.as_view(success_url="/user/password_changed/"), name='password_change' ),
    path('password_changed/', PasswordChangeView.as_view(template_name="user/password_changed.html"), name='password_changed' ),
]

items/models.py
from django.db import models
from django.conf import settings
from django.utils.text import slugify


class Category(models.Model):
    COLORS = (
        ('S', 'success'),
        ('P', 'primary'),
        ('I', 'info'),
        ('W', 'warning'),
        ('D', 'danger'),
        ('A', 'dark'),
        ('E', 'secondary'),
        ('L', 'light')
    )

    ICONS = (
        ('T', 'mobile-alt'),
        ('B', 'book'),
        ('M', 'music'),
        ('C', 'car'),
        ('H', 'home'),
        ('A', 'basketball-ball'),
        ('E', 'headphones'),
        ('D', 'baby-carriage'),
    )
    name = models.CharField(max_length=50)
    color = models.CharField(max_length=1, choices=COLORS, default='P')
    icon = models.CharField(max_length=1, choices=ICONS, default='B')

    slug = models.SlugField(unique=True, null=True, blank=True)

    def save(self, *args, **kwargs):
        self.slug = slugify(self.name)
        super(Category, self).save(*args, **kwargs)

    def __str__(self):
        return self.name    


class Item(models.Model):
    owner = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.SET_NULL, null=True, related_name='items')
    name = models.CharField(max_length=50)
    description = models.TextField(max_length=250)
    price = models.FloatField()
    picture = models.ImageField(upload_to='item_pictures/', default="item_pictures/default.jpg")
    is_available = models.BooleanField(default=True)
    created_at = models.DateField(auto_now_add=True)
    updated_at = models.DateField(auto_now=True)
    category = models.ForeignKey(Category, on_delete=models.DO_NOTHING, related_name='items')

    slug = models.SlugField(unique=True, null=True, blank=True)

    def save(self, *args, **kwargs):
        self.slug = slugify(self.name)
        return super(Item, self).save(*args, **kwargs)
    def __str__(self):
        return self.name
    

class ItemRental(models.Model):
    item = models.ForeignKey(Item, on_delete=models.SET_NULL, null=True)
    hirer = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.SET_NULL, null=True)
    fulfilled = models.BooleanField(default=False)
    created = models.DateTimeField(auto_now_add=True)

users/models.py
from django.db import models
from django.conf import settings
from django.contrib.auth.models import User,AbstractUser

class UserProfile(AbstractUser):
    telephone = models.CharField(max_length=30)
    location = models.CharField(max_length=50)
    birth_date = models.DateField(auto_now=False,null=True,blank=True)
    profile_picture = models.ImageField(default='profile_pictures/default.jpg', upload_to='profile_pictures/')    

users/forms.py
from django import forms
from django.contrib.auth.forms import UserCreationForm,AuthenticationForm,PasswordResetForm,UserChangeForm,ReadOnlyPasswordHashField,ReadOnlyPasswordHashWidget
from django.contrib.auth.models import User
from .models import UserProfile
from django.utils.translation import gettext, gettext_lazy as _
from django.contrib.auth.hashers import (
    UNUSABLE_PASSWORD_PREFIX, identify_hasher,
)
class RealDateInput(forms.DateInput):
    input_type = "date"


class UserRegisterForm(UserCreationForm):
    class Meta(UserCreationForm):
        model = UserProfile
        fields =UserCreationForm.Meta.fields +  (
        "password1","password2", "email","first_name", "last_name","telephone", "birth_date", "location", "profile_picture")
        widgets = {"birthday": RealDateInput}
class UserLoginForm(AuthenticationForm):
    remember_me = forms.BooleanField(required=False)


class ProfileUpdateForm(UserChangeForm,ReadOnlyPasswordHashField,ReadOnlyPasswordHashWidget):
    password = ReadOnlyPasswordHashField(
        label=_("Password"),
        help_text=_(""),
    )     
    template_name = 'user/profile_edit.html'

  
    class Meta(UserChangeForm):
        model = UserProfile
        fields = [
            'first_name', 'last_name', 'email', 'telephone', 'birth_date', 'location', 'profile_picture']

users/views.py
from django.shortcuts import render
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic import DetailView, CreateView,UpdateView,FormView
from django.contrib.auth.forms import UserCreationForm,PasswordChangeForm
from .forms import UserRegisterForm,UserLoginForm,ProfileUpdateForm
from crispy_forms.helper import FormHelper
from crispy_forms.layout import Layout, Fieldset, ButtonHolder, Submit
from django.shortcuts import redirect, get_object_or_404
from django.contrib.auth.views import LoginView,LogoutView,PasswordResetForm,PasswordChangeView
from django.contrib.auth import login
from django.views.generic.detail import BaseDetailView,DetailView,SingleObjectMixin
from django.conf import settings
from .models import UserProfile
from items.models import Item
from django.contrib.auth.models import User
from django.urls import reverse_lazy
from django.db.models import Q
from items.models import ItemRental
from django.utils.translation import gettext, gettext_lazy as _



class RegistrationView(FormView):
    form_class = UserRegisterForm   
    template_name='user/register.html'
    success_url='/user/login/'

    def form_valid(self, form):
        form.save()
        return super().form_valid(form)

class Login(LoginView):
    authentication_form = UserLoginForm
    form_class = UserLoginForm
    template_name = 'user/login.html'
    success_url=''
    def form_valid(self, form):
        remember_me = form.cleaned_data['remember_me']
        login(self.request, form.get_user())
        if remember_me:
            self.request.session.set_expiry(1209600)
        return super(LoginView, self).form_valid(form)   

class PasswordResetView(FormView):
    form_class = PasswordResetForm
    template_name = "user/password_reset.html"
    success_url='/'


class ProfileDetailView(DetailView):
    model = UserProfile
    template_name="user/profile.html"
    context_object_name = "profile"
    is_me = False
    def get_object(self, queryset=None):
        if self.is_me:
            return self.request.user
        else:
            return super().get_object(queryset)
    def get_context_data(self, **kwargs):
        if self.is_me:
            context = super().get_context_data(**kwargs)
            o = UserProfile.objects.get(pk=self.request.user.id)
            context["itemrentals"] = ItemRental.objects.filter(hirer=o.id)
            context["is_me"] = self.is_me   
            return context
        else:
            context = super().get_context_data(**kwargs)
            o = UserProfile.objects.get(pk=self.kwargs['pk'])
            context["is_me"] = self.is_me   
            return context
        
class ProfileUpdateView(LoginRequiredMixin, UpdateView):
    model = UserProfile
    form_class = ProfileUpdateForm
    template_name="user/profile_edit.html"
    success_url="/user/profile/me"
    def get_object(self, queryset=None):
        return self.request.user

class PasswordChangeView(PasswordChangeView):
    form_class = PasswordChangeForm
    success_url = reverse_lazy('password_change_done')
    template_name = 'user/password_change.html'
    title = _('Password change')

templates/user/logged_out.html
{% extends "base.html" %}
{% load i18n %}
{% block title %}Logged Out{%endblock%}
{% block body %}
<h1>Başarılı bir şekilde çıkış yaptınız.</h1>
<h3>Yönlendiriliyorsunuz.</h3>
<meta http-equiv="refresh" content="2;url=/" />

<noscript><a href="/user/logged_out/">Devam etmek için tıklayınız.</a>
</noscript>
{% endblock %}

templates/user/login.html
{% extends "base.html" %}

{% block title %}Login to Account{% endblock %}
{% load crispy_forms_tags %}

{% block body %}
    <form method="POST" class="form-group" style="margin-top: 5%;">
	{% csrf_token %}
	<div class="row justify-content-center">
		<div class="col-6">
		{{ form|crispy }}
		<div class="col text-center">
			<button type="submit" class="btn btn-success">Login</button>
            <a href="/user/reset_password/">Forgotten your password?</a>

		</div>
		</div>
	</div>
    </form>
{% endblock %}

templates/user/password_change.html
{% extends "base.html" %}

{% block title %}Password Reset{% endblock %}
{% load crispy_forms_tags %}

{% block body %}
    <form method="POST" class="form-group" style="margin-top: 5%;">
	{% csrf_token %}
	<div class="row justify-content-center">
		<div class="col-6">
		{{ form|crispy }}
		<div class="col text-center">
			<button type="submit" class="btn btn-success">Search</button>

		</div>
		</div>
	</div>
    </form>
{% endblock %}

templates/user/password_changed.html
{% extends "base.html" %}
{% load i18n %}
{% block title %}
{% trans "Logged Out" %}
{% endblock %}
{% block body %}
<h1>Şifreniz başarıyla değiştirildi.</h1>
<h3>Yönlendiriliyorsunuz.</h3>

<meta http-equiv="refresh" content="2;url=/" />



<noscript><a href="{% url "users:me" %}">Click here to proceed to login page.</a>
</noscript>
{% endblock %}

templates/user/password_reset.html
{% extends "base.html" %}

{% block title %}Password Reset{% endblock %}
{% load crispy_forms_tags %}

{% block body %}
    <form method="POST" class="form-group" style="margin-top: 5%;">
	{% csrf_token %}
	<div class="row justify-content-center">
		<div class="col-6">
		{{ form|crispy }}
		<div class="col text-center">
			<button type="submit" class="btn btn-success">Search</button>

		</div>
		</div>
	</div>
    </form>
{% endblock %}

templates/user/profile.html
{% extends "base.html" %}
{% block title %}Password Reset{% endblock %}


{% block body %}


<div class="container">
        <div class="row">
                <div class="col-3">
                        <img src="{{profile.profile_picture.url}}" alt="Profil Resmi" width="300px" height="430px">
                        <div style="text-align: center; margin-top:2%;">
                                        {% if is_me %} 
                                        <a class="btn btn-secondary btn-lg" href="{% url "users:profile_update" %}">
                                                <small>Güncelle</small>
                                        </a>
                                        <a class="btn btn-secondary btn-lg" href="{% url "communication:messages_list" %}">
                                                <small>Mesajlar</small>
                                        </a>
                                        {% endif %}
                        </div>
                </div>
                <div class="col-9">
                        <ul class="list-group">
                                <li class="list-group-item active">Kullanıcı Bilgileri 
                                        {% if request.user.id == profile.id %}
                                <a class="btn btn-danger btn-sm" href="{% url 'rent_requests' %}" style="margin-left: 70%;">Gelen İstekler</a>
                                        {% endif %}
                                </li>

                                <li class="list-group-item"> <span class="font-weight-bold">Kullanıcı Adı: </span>  {{ profile.username }}</li>
                                <li class="list-group-item"> <span class="font-weight-bold"> Ad: </span> {{ profile.first_name }}</li>
                                <li class="list-group-item"> <span class="font-weight-bold"> Soyad: </span> {{ profile.last_name }}</li>
                                <li class="list-group-item"> <span class="font-weight-bold"> Email: </span> {{ profile.email }}</li>
                                <li class="list-group-item"> <span class="font-weight-bold" > Son Giriş: </span> {{ profile.last_login }}</li>
                                <li class="list-group-item"> <span class="font-weight-bold" > Telefon: </span> {{ profile.telephone }}</li>
                                <li class="list-group-item"> <span class="font-weight-bold" > Doğum Tarihi: </span> {{ profile.birth_date }}</li>
                                <li class="list-group-item"> <span class="font-weight-bold" > Konum: </span> {{ profile.location }}</li>
                        </ul>
                </div>

        </div>
        <br>

        <div class="row" style="text-align: center; margin-top: 3%;">
                <div class="col-6">
                        <h5 class="font-weight-bold" >Ürünleriniz</h5>
                        <hr>
                        <ul class="list-unstyled">
                                {% for item in profile.items.all %}
                                <li class="media">
                                        <a href="{% url 'item-detail' item.slug %}"> <img src="{{item.picture.url}}" class="mr-3 profile_item_picture" alt="Ürün Resmi" height="150px" width="150px"></a>
                                        <div class="media-body">
                                                <h5 class="mt-0 mb-1"><a href="{% url 'item-detail' item.slug %}">{{item.name}}</a></h5>
                                                <p>{{item.description|truncatewords:5}}...</p>
                                                <div class="row">
                                                        <div class="col-6">
                                                                Durum: 
                                                                {% if item.is_available %}
                                                                        Kiralık
                                                                {% else %}
                                                                        Kiralık Değil
                                                                {% endif %}
                                                        </div>
                                                        <div class="col-6">
                                                                <div class="btn-group">
                                                        {% if request.user.id == profile.id%}
                                                                {% if item.is_available %}
                                                                        
                                                                        <a class="btn btn-danger btn-sm" href="{% url 'switchrent' pk=item.id %}">Kiralıktan Kaldır</a>
                                                                        <a class="btn btn-warning btn-sm" href="{% url 'item-update' itemslug=item.slug %}">Güncelle</a>
                                                                {% else %}
                                                                        <a class="btn btn-success btn-sm" href="{% url 'switchrent' pk=item.id %}">Kiralık Listesine Ekle</a>
                                                                        <a class="btn btn-warning btn-sm"  href="{% url 'item-update' itemslug=item.slug %}">Güncelle</a>
                                                                {% endif %}
                                                                {% endif %}
                                                                </div>
                                                        </div>
                                                </div>
                                        </div>
                                </li>
                                <hr>
                                {% endfor %}
                        </ul>
                </div>

                <div class="col-6">
                        {% if request.user.id == profile.id%}
                        <h5 class="font-weight-bold" >Kiralama İstekleriniz</h5>
                        <hr>
                        <ul class="list-unstyled">
                                {% for i in profile.itemrental_set.all %}
                                <li class="media">
                                       <a href="{% url 'item-detail' i.item.slug %}"> <img  src="{{i.item.picture.url}}" class="mr-3 profile_item_picture" alt="..." height="150px" width="150px"></a>
                                        <div class="media-body">
                                                <h5 class="mt-0 mb-1"><a href="{% url 'item-detail' i.item.slug %}">{{i.item.name}}<a></h5>
                                                <div class="row">
                                                        <div class="col-6">
                                                                Ürünü Sahibi: {{i.item.owner}}
                                                                <br>
                                                                Oluşturulma Zamanı: {{i.created}}
                                                        </div>
                                                        <div class="col-6">
                                                                <a class="btn btn-danger" href="{% url 'cancel_request' pk=i.item.owner.id rental_pk=i.id %}">İptal Et</a>
                                                        </div>
                                                </div>
                                        </div>
                                </li>
                                <hr>
                                {% endfor %}
                        </ul>
                        {% endif %}
                </div>
        </div>
        
</div>
{% endblock %}

templates/user/profile_edit.html
{% extends "base.html" %}

{% block title %}Create an Account{% endblock %}
{% load crispy_forms_tags %}

{% block body %}
<form method="POST" class="form-group" style="margin-top: 5%;" enctype="multipart/form-data">
	{% csrf_token %}
	<div class="row justify-content-center">
		<div class="col-6">
			{{ form|crispy }}
			<a href="/user/change_password/">Şifrenizi değiştirmek için tıklayınız.</a>
			<div class="col text-center">
				<button type="submit" class="btn btn-success">Kaydet</button>
			</div>
		</div>
	</div>
</form>
{% endblock %}

templates/user/register.html
{% extends "base.html" %}

{% block title %}Create an Account{% endblock %}
{% load crispy_forms_tags %}

{% block body %}
    <form method="POST" class="form-group" style="margin-top: 5%;" enctype="multipart/form-data">
	{% csrf_token %}
	<div class="row justify-content-center">
		<div class="col-6">
		{{ form|crispy }}
		<div class="col text-center">
			<button type="submit" class="btn btn-success">Register</button>
			Have an account? <a href="{%url "users:login"%}">Login</a>
		</div>
		</div>
	</div>
    </form>
{% endblock %}